﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

namespace howto_make_button_image
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Save the image into a file.
        private void mnuFileSaveAs_Click(object sender, EventArgs e)
        {
            if (sfdButtonFile.ShowDialog() == DialogResult.OK)
            {
                SaveBitmapUsingExtension(TheBitmap, sfdButtonFile.FileName);
            }
        }

        // Save the file with the appropriate format.
        // Throw a NotSupportedException if the file
        // has an unknown extension.
        public void SaveBitmapUsingExtension(Bitmap bm, string filename)
        {
            string extension = Path.GetExtension(filename);
            switch (extension.ToLower())
            {
                case ".bmp":
                    bm.Save(filename, ImageFormat.Bmp);
                    break;
                case ".exif":
                    bm.Save(filename, ImageFormat.Exif);
                    break;
                case ".gif":
                    bm.Save(filename, ImageFormat.Gif);
                    break;
                case ".jpg":
                case ".jpeg":
                    bm.Save(filename, ImageFormat.Jpeg);
                    break;
                case ".png":
                    bm.Save(filename, ImageFormat.Png);
                    break;
                case ".tif":
                case ".tiff":
                    bm.Save(filename, ImageFormat.Tiff);
                    break;
                default:
                    throw new NotSupportedException(
                        "Unknown file extension " + extension);
            }
        }

        // The bitmap.
        Bitmap TheBitmap = new Bitmap(16, 16);

        // Draw the image to save.
        private void Form1_Load(object sender, EventArgs e)
        {
            // Fit the picture we draw.
            picCanvas.SizeMode = PictureBoxSizeMode.AutoSize;

            // Make the bitmap.
            TheBitmap = new Bitmap(16, 16);

            using (Graphics gr = Graphics.FromImage(TheBitmap))
            {
                gr.SmoothingMode = SmoothingMode.AntiAlias;

                // Give it a transparent background.
                gr.Clear(Color.Transparent);

                // Draw.
                using (Pen the_pen = new Pen(Color.Blue, 3))
                {
                    the_pen.EndCap = LineCap.Round;
                    the_pen.StartCap = LineCap.Round;
                    the_pen.LineJoin = LineJoin.Round;

                    // Down expander.
                    Point[] points =
                    {
                        new Point(3, 2),
                        new Point(8, 7),
                        new Point(13, 2),
                    };
                    gr.DrawLines(the_pen, points);

                    for (int i = 0; i < points.Length; i++)
                    {
                        points[i].Y += 6;
                    }
                    gr.DrawLines(the_pen, points);

                    //// Up expander.
                    //Point[] points =
                    //{
                    //    new Point(3, 13),
                    //    new Point(8, 8),
                    //    new Point(13, 13),
                    //};
                    //gr.DrawLines(the_pen, points);

                    //for (int i = 0; i < points.Length; i++)
                    //{
                    //    points[i].Y -= 6;
                    //}
                    //gr.DrawLines(the_pen, points);
                }
            }

            // Display the result.
            picCanvas.Image = TheBitmap;
        }
    }
}
